/*
 * A231216 Demo: Blink Test (Arduino style)
 * 
 *
 */

#define _XTAL_FREQ 4000000

// CONFIG
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTOSC oscillator: I/O function on RA6/OSC2/CLKOUT pin, I/O function on RA7/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (PWRT enabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Detect Enable bit (BOD enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB4/PGM pin has digital I/O function, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Data memory code protection off)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)

#include <xc.h>
#include <stdint.h>

uint8_t    Key1Pressed = 0;
void Delay500();

void main()
{
    TRISA0 = 0;                         // RA0 as output
    CMCON = 0b00000111;                 // Disable comparators to enable RA0-RA3 input
    
    // Blinks until Key1 is pressed
    while(Key1Pressed == 0)
    {
        RA0 = 0;
        Delay500();
            
        RA0 = 1;
        Delay500();
    }
    while (Key1Pressed == 1);           // Loop for ever if Key1 was pressed
}

void Delay500()
{
    for (int i= 0; i < 50; i++)
    {
        TRISA0 = 1;                     // RA0 as input
        if (RA0 == 0) Key1Pressed = 1;  // Key1 is pressed (RA0 = LOW)
        TRISA0 = 0;                     // RA0 as output
        __delay_ms(10);
    }
}